
#include <math.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "conkywx.h"



double agetodate(double td1, int *dd, int *hh, int *mm)
{
	double a, b, c,d ;
	d = (int)(td1); // days
	a = ( td1 - d);
	b = a * 24; 				// hours
	c = ( b - (int)(b))*60;		// min
	*dd = d;
	*hh = b;
	*mm = c;
	return 0;
}

double trim_val ( double num1 )
{
	num1 *= 100;
	// printf( "\nMoonPhaseCalc rounded=\"%1.0d\"\n", (int)(num1 +=.5));
	return (int)(num1 +=.5);
}

struct tm mk_tm(int year, int month, int day, int hour, int minute, int second)
{
  struct tm tmv =
  {
    .tm_hour = hour, .tm_min = minute, .tm_sec = second,
    .tm_year = year - 1900, .tm_mon = month - 1, .tm_mday = day,
    .tm_isdst = -1
  };

  mktime(&tmv);

  return tmv;
}

// remove all instances of a character from a string
void remove_chars(char* str, char c) {
    char *pr = str, *pw = str;
    while (*pr) {
        *pw = *pr++;
        pw += (*pw != c);
    }
    *pw = '\0';
}

void moonWords(const char *string) {
	//char moonp3[30];
	char *space;
	strcpy(buffer, string);
	space = strchr(buffer,' ');
	if (space != NULL ) {
		*space++ = '\0';
	}

	printf("moonp1=\"%s\"\n", buffer);
	printf("moonp2=\"%s\"\n", space);

	if ((!strcmp(buffer, "New"))) {
		printf("moonp3=\"%s\"\n", "New Moon");
	}
	else if ((!strcmp(buffer, "Full"))) {
		printf("moonp3=\"%s\"\n", "Full Moon");
	}
	else if ((!strcmp(space, "Quarter"))) {
		printf("moonp3=\"%s %s\"\n", buffer,"Qtr");
	}
	else {
		printf("moonp3=\"%s\"\n", buffer);
	}
}

/*  JDATE  --  Convert internal GMT date and time to Julian day
			   and fraction.  */
long jdate(struct tm *t)
{
	long c, m, y;

	y = t->tm_year + 1900;
	m = t->tm_mon + 1;

	if (m > 2)
	{
		m = m - 3;
	}
	else
	{
		m = m + 9;
		y = y - 1;
	}

	c = y / 100L;              /* Compute century */
	y -= 100L * c;
	return t->tm_mday + (c * 146097L) / 4 + (y * 1461L) / 4 +
			(m * 153L + 2) / 5 + 1721119L;
}


/* JTIME --    Convert internal GMT date and time to astronomical Julian
			   time (i.e. Julian date plus day fraction, expressed as
			   a double).  */

double jtime(struct tm *t)
{
	return (jdate(t) - 0.5) +
		(t->tm_sec + 60 * (t->tm_min + 60 * t->tm_hour)) / 86400.0;
}

/*  JYEAR  --  Convert Julian date to year, month, day, which are
			   returned via integer pointers to integers.  */

void jyear(double td, double z1, int *yy, int *mm, int *dd)
{
	double j, d, y, m;

	td += (0.5 + z1);                 /* Astronomical to civil */
	j = floor(td);
	j = j - 1721119.0;
	y = floor(((4 * j) - 1) / 146097.0);
	j = (j * 4.0) - (1.0 + (146097.0 * y));
	d = floor(j / 4.0);
	j = floor(((4.0 * d) + 3.0) / 1461.0);
	d = ((4.0 * d) + 3.0) - (1461.0 * j);
	d = floor((d + 4.0) / 4.0);
	m = floor(((5.0 * d) - 3) / 153.0);
	d = (5.0 * d) - (3.0 + (153.0 * m));
	d = floor((d + 5.0) / 5.0);
	y = (100.0 * y) + j;

	if (m < 10.0)
	{
		m = m + 3;
	}
	else
	{
		m = m - 9;
		y = y + 1;
	}

	*yy = y;
	*mm = m;
	*dd = d;
}


void jhms(double td, double z1, int *yy, int *mm, int *dd, int *h, int *min, int *s)
{
	long ij;
	double j, d, y, m;

	td += (0.5 + z1);                  /* Astronomical to civil */
	ij = (td - floor(td)) * 86400.0;
	*h = ij / 3600L;
	*min = (ij / 60L) % 60L;
	*s = ij % 60L;


	// td += (0.5 + z1);                 /* Astronomical to civil */
	j = floor(td);
	j = j - 1721119.0;
	y = floor(((4 * j) - 1) / 146097.0);
	j = (j * 4.0) - (1.0 + (146097.0 * y));
	d = floor(j / 4.0);
	j = floor(((4.0 * d) + 3.0) / 1461.0);
	d = ((4.0 * d) + 3.0) - (1461.0 * j);
	d = floor((d + 4.0) / 4.0);
	m = floor(((5.0 * d) - 3) / 153.0);
	d = (5.0 * d) - (3.0 + (153.0 * m));
	d = floor((d + 5.0) / 5.0);
	y = (100.0 * y) + j;

	if (m < 10.0)
	{
		m = m + 3;
	}
	else
	{
		m = m - 9;
		y = y + 1;
	}

	*yy = y;
	*mm = m;
	*dd = d;
}


/*
 * MEANPHASE  --  Calculates time of the mean new Moon for a given
 *		base date.  This argument K to this function is
 *		the precomputed synodic month index, given by:
 *
 *			K = (year - 1900) * 12.3685
 *
 *		where year is expressed as a year and fractional year.
 */

#if 0
/* This funtion is no longer used/required */
 *	double meanphase (double sdate, double k)
 *	{
 *		double	t, t2, t3, nt1;
 *
 *		/* Time in Julian centuries from 1900 January 0.5 */
 *		t = (sdate - 2415020.0) / 36525;
 *		t2 = t * t;			/* Square for frequent use */
 *		t3 = t2 * t;			/* Cube for frequent use */
 *
 *		nt1 = 2415020.75933 + synmonth * k
 *			+ 0.0001178 * t2
 *			- 0.000000155 * t3
 *			+ 0.00033 * dsin(166.56 + 132.87 * t - 0.009173 * t2);
 *
 *		return nt1;
 *	}
#endif






/*
 * TRUEPHASE  --  Given a K value used to determine the
 *		mean phase of the new moon, and a phase
 *		selector (0.0, 0.25, 0.5, 0.75), obtain
 *		the true, corrected phase time.
 */

double truephase(double k, double phase)
{
	double t, t2, t3, pt, m, mprime, f;
	int apcor = FALSE;

	k += phase;				/* Add phase to new moon time */
	t = k / 1236.85;		/* Time in Julian centuries from 1900 January 0.5 */
	t2 = t * t;				/* Square for frequent use */
	t3 = t2 * t;			/* Cube for frequent use */
	pt = 2415020.75933		/* Mean time of phase */
	     + synmonth * k
	     + 0.0001178 * t2
	     - 0.000000155 * t3
	     + 0.00033 * dsin(166.56 + 132.87 * t - 0.009173 * t2);

        m = 359.2242               /* Sun's mean anomaly */
	    + 29.10535608 * k
	    - 0.0000333 * t2
	    - 0.00000347 * t3;
        mprime = 306.0253          /* Moon's mean anomaly */
	    + 385.81691806 * k
	    + 0.0107306 * t2
	    + 0.00001236 * t3;
        f = 21.2964                /* Moon's argument of latitude */
	    + 390.67050646 * k
	    - 0.0016528 * t2
	    - 0.00000239 * t3;
	if ((phase < 0.01) || (abs(phase - 0.5) < 0.01)) {

	   /* Corrections for New and Full Moon */

	   pt +=     (0.1734 - 0.000393 * t) * dsin(m)
		    + 0.0021 * dsin(2 * m)
		    - 0.4068 * dsin(mprime)
		    + 0.0161 * dsin(2 * mprime)
		    - 0.0004 * dsin(3 * mprime)
		    + 0.0104 * dsin(2 * f)
		    - 0.0051 * dsin(m + mprime)
		    - 0.0074 * dsin(m - mprime)
		    + 0.0004 * dsin(2 * f + m)
		    - 0.0004 * dsin(2 * f - m)
		    - 0.0006 * dsin(2 * f + mprime)
		    + 0.0010 * dsin(2 * f - mprime)
		    + 0.0005 * dsin(m + 2 * mprime);
	   apcor = TRUE;
	} else if ((abs(phase - 0.25) < 0.01 || (abs(phase - 0.75) < 0.01))) {
	   pt +=     (0.1721 - 0.0004 * t) * dsin(m)
		    + 0.0021 * dsin(2 * m)
		    - 0.6280 * dsin(mprime)
		    + 0.0089 * dsin(2 * mprime)
		    - 0.0004 * dsin(3 * mprime)
		    + 0.0079 * dsin(2 * f)
		    - 0.0119 * dsin(m + mprime)
		    - 0.0047 * dsin(m - mprime)
		    + 0.0003 * dsin(2 * f + m)
		    - 0.0004 * dsin(2 * f - m)
		    - 0.0006 * dsin(2 * f + mprime)
		    + 0.0021 * dsin(2 * f - mprime)
		    + 0.0003 * dsin(m + 2 * mprime)
		    + 0.0004 * dsin(m - 2 * mprime)
		    - 0.0003 * dsin(2 * m + mprime);
	   if (phase < 0.5)
	      /* First quarter correction */
	      pt += 0.0028 - 0.0004 * dcos(m) + 0.0003 * dcos(mprime);
	   else
	      /* Last quarter correction */
	      pt += -0.0028 + 0.0004 * dcos(m) - 0.0003 * dcos(mprime);
	   apcor = TRUE;
	}
	if (!apcor) {
	   (void)fprintf (stderr,
                "TRUEPHASE called with invalid phase selector.\n");
	   abort();
	}
	return pt;
}




/*
 * PHASEHUNT  --  Find time of phases of the moon which surround
 *		the current date.  Five phases are found, starting
 *		and ending with the new moons which bound the
 *		current lunation.
 */

void phasehunt (double sdate, double z1, double phases[5])
{
	double	adate, k1, k2;  /*, nt1, nt2; */
	int	yy, mm, dd;

	adate = sdate - 45;

	jyear(adate, z1, &yy, &mm, &dd);
	k1 = floor((yy + ((mm - 1) * (1.0 / 12.0)) - 1900) * 12.3685);

	sdate -= 0.5;

/*	adate = nt1 = meanphase(adate, k1);*/
	while (TRUE)
	{
/*		adate += synmonth;*/
		k2 = k1 + 1;
/*		nt2 = meanphase(adate, k2);*/

		/* was: if (nt1 <= sdate && nt2 > sdate) */

		phases [0] = truephase (k1, 0.0);
		phases [4] = truephase (k2, 0.0);
		if ( phases[0]<=sdate && phases[4]>sdate )
			break;

/*		nt1 = nt2;*/
		k1 = k2;
	}
	phases [0] = truephase (k1, 0.0);
	phases [1] = truephase (k1, 0.25);
	phases [2] = truephase (k1, 0.5);
	phases [3] = truephase (k1, 0.75);
	phases [4] = (truephase (k2, 0.0));

}



/*  KEPLER  --  Solve the equation of Kepler.  */

double kepler(double m, double ecc)
	{
	double e, delta;

	e = m = torad(m);
	do
		{
		delta = e - ecc * sin(e) - m;
		e -= delta / (1 - ecc * cos(e));
		}
	while (abs(delta) > EPSILON);

	return e;
	}


/*  PHASE  --  Calculate phase of moon as a fraction:

		The argument is the time for which the phase is requested,
		expressed as a Julian date and fraction.  Returns the terminator
		phase angle as a percentage of a full circle (i.e., 0 to 1),
		and stores into pointer arguments the illuminated fraction of
		the Moon's disc, the Moon's age in days and fraction, the
		distance of the Moon from the centre of the Earth, and the
		angular diameter subtended by the Moon as seen by an observer
		at the centre of the Earth.

		pphase.............Illuminated fraction
		mage...............Age of moon in days
		dist...............Distance in kilometres
		angdia.............Angular diameter in degrees
		sudist.............Distance to Sun
		suangdia...........Sun's angular diameter
*/

double phase(double pdate, double *pphase, double *mage, double *dist, double *angdia, double *sudist, double *suangdia)
{
	double Day, N, M, Ec, Lambdasun, ml, MM, MN, Ev, Ae, A3, MmP,
		   mEc, A4, lP, V, lPP, NP, y, x, Lambdamoon, BetaM,
		   MoonAge, MoonPhase,
		   MoonDist, MoonDFrac, MoonAng, MoonPar,
		   F, SunDist, SunAng;

	/* Calculation of the Sun's position */

	Day = pdate - epoch;        /* Date within epoch */
	N = fixangle((360 / 365.2422) * Day); /* Mean anomaly of the Sun */
	M = fixangle(N + elonge - elongp);    /* Convert from perigee co-ordinates to epoch 1980.0 */
	Ec = kepler(M, eccent);     /* Solve equation of Kepler */
	Ec = sqrt((1 + eccent) / (1 - eccent)) * tan(Ec / 2);
	Ec = 2 * todeg(atan(Ec));   /* True anomaly */
	Lambdasun = fixangle(Ec + elongp);  /* Sun's geocentric ecliptic longitude */
	F = ((1 + eccent * cos(torad(Ec))) / (1 - eccent * eccent)); /* Orbital distance factor */
	SunDist = sunsmax / F;      /* Distance to Sun in km */
	SunAng = F * sunangsiz;     /* Sun's angular size in degrees */

	/*
	 *  Calculation of the Moon's position
	 */

	/* Moon's mean longitude */
	ml = fixangle(13.1763966 * Day + mmlong);

	/* Moon's mean anomaly */
	MM = fixangle(ml - 0.1114041 * Day - mmlongp);

	/* Moon's ascending node mean longitude */
	MN = fixangle(mlnode - 0.0529539 * Day);

	/* Evection */
	Ev = 1.2739 * sin(torad(2 * (ml - Lambdasun) - MM));

	/* Annual equation */
	Ae = 0.1858 * sin(torad(M));

	/* Correction term */
	A3 = 0.37 * sin(torad(M));

	/* Corrected anomaly */
	MmP = MM + Ev - Ae - A3;

	/* Correction for the equation of the centre */
	mEc = 6.2886 * sin(torad(MmP));

	/* Another correction term */
	A4 = 0.214 * sin(torad(2 * MmP));

	/* Corrected longitude */
	lP = ml + Ev + mEc - Ae + A4;

	/* Variation */
	V = 0.6583 * sin(torad(2 * (lP - Lambdasun)));

	/* True longitude */
	lPP = lP + V;

	/* Corrected longitude of the node */
	NP = MN - 0.16 * sin(torad(M));

	/* Y inclination coordinate */
	y = sin(torad(lPP - NP)) * cos(torad(minc));

	/* X inclination coordinate */
	x = cos(torad(lPP - NP));

	/* Ecliptic longitude */
	Lambdamoon = todeg(atan2(y, x));
	Lambdamoon += NP;

	/* Ecliptic latitude */
	BetaM = todeg(asin(sin(torad(lPP - NP)) * sin(torad(minc))));

	/*
	 *  Calculation of the phase of the Moon
	 */

	/* Age of the Moon in degrees */
	MoonAge = lPP - Lambdasun;

	/* Phase of the Moon */
	MoonPhase = (1 - cos(torad(MoonAge))) / 2;

	/*
	 *  Calculate distance of moon from the centre of the Earth
	 */

	MoonDist = (msmax * (1 - mecc * mecc)) / (1 + mecc * cos(torad(MmP + mEc)));

	/*
	 *  Calculate Moon's angular diameter
	 */

	MoonDFrac = MoonDist / msmax;
	MoonAng = mangsiz / MoonDFrac;

	/*
	 *  Calculate Moon's parallax
	 */

	MoonPar = mparallax / MoonDFrac;

	*pphase = MoonPhase;
	*mage = synmonth * (fixangle(MoonAge) / 360.0);
	*dist = MoonDist;
	*angdia = MoonAng;
	*sudist = SunDist;
	*suangdia = SunAng;
	return fixangle(MoonAge) / 360.0;
}
